/* Low level initialization for the board */
/* Copyright (c) American Megatrends, Inc */
/* Modified by Server Engines for P3*/

#include <config.h>
#include <version.h>
#include "pilot3_hw.h"
.include  "pilot3.equ"

.extern pilot3hornet_init
.extern sw_reset_modules
/*----------------------------- Setting up the memory and Flash ----------------------*/
.globl lowlevel_init
lowlevel_init:

	/* Save Return PC */
   	mov 	r10,lr

	ldr	r13,=LMEMSTART+0x5000	@temp stack in local memory yy
/* Check if it is a warm boot. For warm boot skip memory init */
	ldr     	r6,=SYSCONTROL            @0x40100100
   	ldr     	r4, [r6]
	and		r4,r4,#0x2
	cmp		r4,#0x02
	bne		skip_hw_init

	bl		pilot3hornet_init


	
skip_hw_init:
	ldr     	r6,=SYSCONTROL            @0x40100100
   	ldr     	r4, [r6]
	and		r4,r4,#0x2
	cmp		r4,#0x02
	beq		skip_reset_modules

	bl	        sw_reset_modules  @reset all modules

skip_reset_modules:		

// Moved clearing this to reset code of u-boot and linux
// This is done so that firmware can get the status of last boot (Cold/Warm)
//	/* Clear cold boot bit */
	ldr     	r6,=SYSCONTROL            @0x40100100
   	ldr     	r4, [r6]
	bic             r4,r4,#0x2    @=0xFFFFFFFD
	str		r4, [r6]

	
/*	bl		flash_config  */

	/* Return Back to caller */
 	mov		lr, r10
	mov		pc, lr


/*-----------------------------------------------------------------------------------*/
/*							FLASH Configuration										 */
/*-----------------------------------------------------------------------------------*/
/* IMPORTANT: r10 should not be destroyed in this function*/

flash_config:

	/* Save Return PC */
	mov		r9,lr

	/* Return Back to caller */
	mov		lr,r9
	mov		pc, lr

/* No remap function in PILOTII */
/*-----------------------------------------------------------------------------------*/
/*					 Remap Memory -Swap Address of ROM and SDRAM					 */
/*-----------------------------------------------------------------------------------*/
.globl remap_memory
remap_memory:

	/* Save Return PC */
	mov 	r9,lr

	/* Add your SOC Specific Remap if any */

	/* Return Back to caller */
    mov 	lr,r9
	mov		pc, lr

	
.globl sw_reset_modules_asm
sw_reset_modules_asm:
	ldr	r13,=LMEMSTART+0x5000	@temp stack in local memory yy
	bl	sw_reset_modules
	mov     pc,r14

	

