#include <common.h>
#include <config.h>
#include <asm/processor.h>

extern void soc_init(void);

int board_init (void)
{
	DECLARE_GLOBAL_DATA_PTR;

	/*Should match with linux mach type for this board */
	//gd->bd->bi_arch_number = 900;
	gd->bd->bi_arch_number = 1120;
	/* Should match with linux Makefile.boot entry for params-phys-y */
	gd->bd->bi_boot_params = CFG_SDRAM_BASE+0x0100;

	/* Initialize SOC related */
	soc_init();
	return 0;
}


int dram_init (void)
{
	DECLARE_GLOBAL_DATA_PTR;
	bd_t *bd = gd->bd;

	/* Only one Bank*/
	bd->bi_dram[0].start = CFG_SDRAM_BASE;
	bd->bi_dram[0].size = CFG_SDRAM_LEN;
#if 0
//DOES not apply for FPGA
// Print values obtained during DDR Calibration
	if(*(ulong *)0x10000004 == 0x55555555) 
		printf("DDR Calibrate Passed\n");
	else 
		printf("DDR Calibrate Failed\n");
	
  	printf("Median Value for Byte [0]=%d, lptr=%d, rptr=%d\n",
		*(ulong *)0x10000028,*(ulong *)0x10000010,*(ulong *)0x10000014);
  	printf("Median Value for Byte [1]=%d, lptr=%d, rptr=%d\n",
		*(ulong *)0x1000002C,*(ulong *)0x10000018,*(ulong *)0x1000001C);
  	printf ("Current DDR Delay Line Settings\n");
 	printf ("Byte-1: %d, Byte-0: %d\n",
        	*(ulong *)0x10000024,*(ulong *)0x10000020 );
#endif

	return (0);
}

short 
ReadJumperConfig(void)
{
	/* Return Path ID */
	return -1;
}
