#include <common.h>
#include <command.h>
#include <linux/types.h>
#include "soc_hw.h"

// Prototypes
void SSID_init(void);
void GPIO_init(void);
void Serial_GPIO_init(void);
void PWM_init(void);

//Shivah added for Releasing the BKUP SPI Pins from GPIO Mode to BKUP SPI Mode:
void BKUPSPI_release_GPIO_pins(void){
/*
CLEAR_BIT32(0x40100900, 0);
  CLEAR_BIT32(0x40100900, 1);
  CLEAR_BIT32(0x40100900, 4);
  CLEAR_BIT32(0x40100900, 5);
*/
	*((volatile unsigned long *) 0x40100900) &= ~(0x1);
	*((volatile unsigned long *) 0x40100900) &= ~(0x2);
	*((volatile unsigned long *) 0x40100900) &= ~(0x1);
	*((volatile unsigned long *) 0x40100900) &= ~(0x10);
	*((volatile unsigned long *) 0x40100900) &= ~(0x20);
}
//End Shivah added for Releasing the BKUP SPI Pins from GPIO Mode to BKUP SPI Mode:

// System-on-chip init.
void
soc_init(void)
{
//Shivah added for Releasing the BKUP SPI Pins from GPIO Mode to BKUP SPI Mode:
    BKUPSPI_release_GPIO_pins();
//End Shivah added for Releasing the BKUP SPI Pins from GPIO Mode to BKUP SPI Mode:

    /* Do any PILOT-II SOC Initialization here */
    *((volatile u32 *)(SE_MAC_A_BASE +AST_MAC_CSR11)) = 0;
    *((volatile u32 *)(SE_MAC_B_BASE +AST_MAC_CSR11)) = 0;
    SSID_init();
    GPIO_init();
    Serial_GPIO_init();
    PWM_init();
    /* Change CPU freq to max if possible */

    return;
}

void SSID_init(void)
{
}

void GPIO_init(void)
{
}

/******************************************************************************
*
*  Serial_GPIO_init
*
*  This function processes the serial GPIO initialization, clear the output
*  registers, etc.
*
*  Return Value:
*
*     None. 
*
******************************************************************************/
void Serial_GPIO_init(void)
{
}


#define  DIV_CEIL(_a_,_b_)      ((0==((_a_)%(_b_)))   ?((_a_)/(_b_)):(((_a_)/(_b_))+1))
#define  DIV_ROUND(_a_,_b_) (((_b_)>(((_a_)%(_b_))*2))?((_a_)/(_b_)):(((_a_)/(_b_))+1))


void PWM_init (void)
{
}
