/******************************************************************************
*
*                   INTEL CORPORATION PROPRIETARY INFORMATION
*       This software is supplied under the terms of a license agreement or
*       nondisclosure agreement with Intel Corporation and may not be copied
*       or disclosed except in accordance with the terms of that agreement.
*         Copyright (c) 20007 Intel Corporation. All Rights Reserved.
*
*   Source File Information:
*       Workfile:   monolithic.c
*       Revision:   1.0    
*
*   Abstract:	Contains the API's to retrieve the ProdID and RevID values from 
*			uboot environment variable space.
*
******************************************************************************/

#include <common.h>

int 
GetBMCProdID(void)
{
	char ProdID[8];
	if (getenv_r("prodid",ProdID,sizeof(ProdID)) == -1)
	{
		return 0;
	}
	printf("Value of ProdID is = %02X \n",ProdID[0]);
	return ProdID[0];
}

int 
GetBMCRevID(void)
{
	char RevID[8];
	if (getenv_r("revid",RevID,sizeof(RevID)) == -1)
	{
		return 0;
	}
	printf("Value of RevID is = %02X \n",RevID[0]);
	return RevID[0];
}
